Role API broken
Priority: Normal
Assignee: Tomas Strachota
Category: API
Target version: 1.6.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.5.0
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/1486
Description

1.5 changed the Role API format, introducing filters' for roles, rather than straight permissions.

In 1.4.2, curl -s -u admin:changeme -k -H "Content-type:application/json" https://localhost/api/roles returned

{ "name": "Manager", "id": 1, "builtin": 0, "permissions": [ "view_architectures", "create_archite
cture", <snip>

In 1.5.0, curl -s -u admin:changeme -k -H "Content-type:application/json" https://localhost/api/roles returns

{"error":{"message":"undefined method “key?' for #<JSON::Ext::Generator::State:0x00000009afb938>"}
}

The production.log stack trace is attached.

If | change the API version to 2, curl -s -u admin:changeme -k -H "Content-type:application/json" https://localhost/api/v2/roles
The response is

{ "otal": 12, "subtotal": 12, "page": 1, "per_page": 20, "search": null, "sort":{ "by":null, "order":null }, "results":
[{"name":"Manager","id":1,"builtin":0},{"name":"Edit partition tables","id":2,"builtin":0},{"name":"View
hosts","id":3,"builtin":0},{"name":"Edit hosts","id":4,"builtin":0},{"name":"Viewer","id":5,"builtin":0},{"name":"Site
manager","id":6,"builtin":0},{"name":"Default
user","id":7,"builtin":1},{"name":"Anonymous","id":8,"builtin":2},{"name":"Anonymous_admin","id":15,"builtin":0}] }

Which responds with a group of filters instead of actual permissions, as the API documentation suggests.

Lastly, running the command curl -s -u admin:changeme -k -H "Content-type:application/json" -X POST -d @test.json
https://localhost/api/v2/roles, where test.json contains

{ "role":{ "permissions":[ "view_environments", "view_facts”, "view_hostgroups”, "view_hosts", "edit_hosts"
], "name": "tester" }}

gives the error message

{
"error": {"message":"Permission (#72168980) expected, got String (#15746520)"}

}

Related issues:

Related to Foreman - Bug #6532: API for permission related operations lacks s... Closed 07/09/2014
Blocks Foreman - Tracker #4552: New permissions/authorization system issues New
History

#1 - 05/27/2014 03:40 PM - Marek Hulan

- Blocks Tracker #4552: New permissions/authorization system issues added

#2 - 05/29/2014 11:50 AM - Joseph Magen
- Status changed from New to Assigned
- Assignee set to Joseph Magen

- Target version set to 1.8.2

#3 - 05/29/2014 12:37 PM - Joseph Magen
- Status changed from Assigned to Ready For Testing

https://github.com/theforeman/foreman/pull/1486

Michael, can you check if the return information is what you are looking for in v2.

Btw, POSTing or PUTing "permissions": [ "view_architectures", "create_architecture, etc] is not supported afaik in both v1 and v2. Did this work for
you inv1?

#4 - 06/10/2014 09:48 PM - Michael Griffin

Joseph Magen wrote:

https://github.com/theforeman/foreman/pull/1486

Michael, can you check if the return information is what you are looking for in v2.

Btw, POSTing or PUTing "permissions": [ "view_architectures", "create_architecture, etc] is not supported afaik in both v1 and v2. Did this work
for you in v1?

I'm not sure exactly how to check whether the return info is correct. But, yes, the POST/PUT worked in vi1. That was how | created my Role
definitions. If that is not supported, what is the supported way of creating Roles without clicking through the GUI?

#5 - 06/11/2014 02:53 PM - Anonymous

- Target version changed from 1.8.2 to 1.8.1

#6 - 07/07/2014 07:22 AM - Anonymous

- Target version changed from 1.8.1 to 1.8.0

#7 - 07/30/2014 06:49 AM - Anonymous

- Target version changed from 1.8.0to 1.7.5

#8 - 08/07/2014 03:19 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/1486 added

#9 - 08/08/2014 03:54 AM - Dominic Cleal

- Related to Bug #6532: API for permission related operations lacks some functionality added

#10 - 08/08/2014 03:54 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- Assignee changed from Joseph Magen to Tomas Strachota
- % Done changed from 0 to 100

- translation missing: en.field_release set to 10

Should have been fixed via #6532.

Files

stacktrace.txt 17.1 KB 05/27/2014 Michael Griffin

05/11/2024 22


https://github.com/theforeman/foreman/pull/1486
https://github.com/theforeman/foreman/pull/1486
https://projects.theforeman.org/issues/6532
http://www.tcpdf.org

